Index: /trunk/kBuild/tools/VCC80.kmk
===================================================================
--- /trunk/kBuild/tools/VCC80.kmk	(revision 1030)
+++ /trunk/kBuild/tools/VCC80.kmk	(revision 1031)
@@ -142,8 +142,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80_COMPILE_C_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
 TOOL_VCC80_COMPILE_C_DEPEND =
 TOOL_VCC80_COMPILE_C_DEPORD =
-ifndef VCC80_OLD_DEPS
+TOOL_VCC80_COMPILE_C_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
 define TOOL_VCC80_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC80_CC) -c\
@@ -155,17 +154,4 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80_PDB,$(outbase)-obj,idb)
 endef
-else
-define TOOL_VCC80_COMPILE_C_CMDS
-	$(QUIET)$(TOOL_VCC80_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		-Fd$(outbase)-obj.pdb \
-		-Fo$(obj)\
-		$(subst /,\\,$(abspath $(source)))
-	$(QUIET)$(TOOL_VCC80_CC) -E\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		$(subst /,\\,$(abspath $(source)))\
-		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
-endef
-endif
 
 
@@ -183,8 +169,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
 TOOL_VCC80_COMPILE_CXX_DEPEND =
 TOOL_VCC80_COMPILE_CXX_DEPORD =
-ifndef VCC80_OLD_DEPS
+TOOL_VCC80_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
 define TOOL_VCC80_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC80_CXX) -c\
@@ -196,17 +181,4 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80_PDB,$(outbase)-obj,idb)
 endef
-else
-define TOOL_VCC80_COMPILE_CXX_CMDS
-	$(QUIET)$(TOOL_VCC80_CXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		-Fd$(outbase)-obj.pdb \
-		-Fo$(obj)\
-		$(subst /,\\,$(abspath $(source)))
-	$(QUIET)$(TOOL_VCC80_CXX) -E\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		$(subst /,\\,$(abspath $(source)))\
-		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
-endef
-endif
 
 
@@ -247,6 +219,6 @@
 TOOL_VCC80_LINK_LIBRARY_DEPEND = $(othersrc)
 TOOL_VCC80_LINK_LIBRARY_DEPORD =
-ifeq ($(filter append-dash-n,$(KMK_FEATURES)),append-dash-n)
-TOOL_VCC80_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(outbase).pdb $(outbase).rsp
+TOOL_VCC80_LINK_LIBRARY_OUTPUT = $(outbase).rsp
+TOOL_VCC80_LINK_LIBRARY_OUTPUT_MAYBE = $(outbase).lst $(outbase).exp $(outbase).pdb
 define TOOL_VCC80_LINK_LIBRARY_CMDS
 	$(QUIET)$(APPEND) -n $(outbase).rsp \
@@ -258,11 +230,4 @@
 	$(QUIET)$(TOOL_VCC80_AR) $(flags) /OUT:$(out) @$(outbase).rsp
 endef
-else
-TOOL_VCC80_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(outbase).pdb
-define TOOL_VCC80_LINK_LIBRARY_CMDS
-	$(QUIET)$(TOOL_VCC80_AR) $(flags) /OUT:$(out) $(subst /,\\,$(objs) $(filter %.a %.lib,$(othersrc))) \
-		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def))
-endef
-endif
 
 
@@ -283,7 +248,8 @@
 # @param    $(outbase)      Output basename (full). Use this for list files and such.
 #
-TOOL_VCC80_LINK_PROGRAM_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80_LINK_PROGRAM_DEPORD =
+TOOL_VCC80_LINK_PROGRAM_OUTPUT = $(outbase).map
+TOOL_VCC80_LINK_PROGRAM_OUTPUT_MAYBE = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80_LINK_PROGRAM_CMDS
 	$(QUIET)$(TOOL_VCC80_LD) $(flags) \
@@ -316,7 +282,8 @@
 #
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
-TOOL_VCC80_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80_LINK_DLL_DEPEND = $(objs) $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80_LINK_DLL_DEPORD = $(call DIRDEP,$(PATH_LIB))
+TOOL_VCC80_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp
+TOOL_VCC80_LINK_DLL_OUTPUT_MAYBE = $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80_LINK_DLL_CMDS
 	$(QUIET)$(TOOL_VCC80_LD) $(flags) \
@@ -356,7 +323,8 @@
 #
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
-TOOL_VCC80_LINK_SYSMOD_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80_LINK_SYSMOD_DEPORD =
+TOOL_VCC80_LINK_SYSMOD_OUTPUT = $(outbase).map
+TOOL_VCC80_LINK_SYSMOD_OUTPUT_MAYBE = $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80_LINK_SYSMOD_CMDS
 	$(QUIET)$(TOOL_VCC80_LD) $(flags) \
Index: /trunk/kBuild/tools/VCC80AMD64.kmk
===================================================================
--- /trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1030)
+++ /trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1031)
@@ -121,8 +121,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80AMD64_COMPILE_C_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
 TOOL_VCC80AMD64_COMPILE_C_DEPEND =
 TOOL_VCC80AMD64_COMPILE_C_DEPORD =
-ifndef VCC80AMD64_OLD_DEPS
+TOOL_VCC80AMD64_COMPILE_C_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
 define TOOL_VCC80AMD64_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_CC) -c\
@@ -134,17 +133,4 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80AMD64_PDB,$(outbase)-obj,idb)
 endef
-else
-define TOOL_VCC80AMD64_COMPILE_C_CMDS
-	$(QUIET)$(TOOL_VCC80AMD64_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		-Fd$(outbase)-obj.pdb \
-		-Fo$(obj)\
-		$(subst /,\\,$(abspath $(source)))
-	$(QUIET)$(TOOL_VCC80AMD64_CC) -E\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		$(subst /,\\,$(abspath $(source)))\
-		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
-endef
-endif
 
 
@@ -162,8 +148,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80AMD64_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
 TOOL_VCC80AMD64_COMPILE_CXX_DEPEND =
 TOOL_VCC80AMD64_COMPILE_CXX_DEPORD =
-ifndef VCC80AMD64_OLD_DEPS
+TOOL_VCC80AMD64_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
 define TOOL_VCC80AMD64_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_CXX) -c\
@@ -175,17 +160,4 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80AMD64_PDB,$(outbase)-obj,idb)
 endef
-else
-define TOOL_VCC80AMD64_COMPILE_CXX_CMDS
-	$(QUIET)$(TOOL_VCC80AMD64_CXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		-Fd$(outbase)-obj.pdb \
-		-Fo$(obj)\
-		$(subst /,\\,$(abspath $(source)))
-	$(QUIET)$(TOOL_VCC80AMD64_CXX) -E\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		$(subst /,\\,$(abspath $(source)))\
-		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
-endef
-endif
 
 
@@ -203,7 +175,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80AMD64_COMPILE_RC_OUTPUT =
 TOOL_VCC80AMD64_COMPILE_RC_DEPEND =
 TOOL_VCC80AMD64_COMPILE_RC_DEPORD =
+TOOL_VCC80AMD64_COMPILE_RC_OUTPUT =
 define TOOL_VCC80AMD64_COMPILE_RC_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_RC) \
@@ -226,6 +198,6 @@
 TOOL_VCC80AMD64_LINK_LIBRARY_DEPEND = $(othersrc)
 TOOL_VCC80AMD64_LINK_LIBRARY_DEPORD =
-ifeq ($(filter append-dash-n,$(KMK_FEATURES)),append-dash-n)
-TOOL_VCC80AMD64_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(outbase).pdb $(outbase).rsp
+TOOL_VCC80AMD64_LINK_LIBRARY_OUTPUT = $(outbase).rsp
+TOOL_VCC80AMD64_LINK_LIBRARY_OUTPUT_MAYBE = $(outbase).lst $(outbase).exp $(outbase).pdb
 define TOOL_VCC80AMD64_LINK_LIBRARY_CMDS
 	$(QUIET)$(APPEND) -n $(outbase).rsp \
@@ -237,11 +209,4 @@
 	$(QUIET)$(TOOL_VCC80AMD64_AR) $(flags) /OUT:$(out) @$(outbase).rsp
 endef
-else
-TOOL_VCC80AMD64_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(outbase).pdb
-define TOOL_VCC80AMD64_LINK_LIBRARY_CMDS
-	$(QUIET)$(TOOL_VCC80AMD64_AR) $(flags) /OUT:$(out) $(subst /,\\,$(objs) $(filter %.a %.lib,$(othersrc))) \
-		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def))
-endef
-endif
 
 
@@ -260,7 +225,8 @@
 # @param    $(outbase)      Output basename (full). Use this for list files and such.
 #
-TOOL_VCC80AMD64_LINK_PROGRAM_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80AMD64_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80AMD64_LINK_PROGRAM_DEPORD =
+TOOL_VCC80AMD64_LINK_PROGRAM_OUTPUT = $(outbase).map
+TOOL_VCC80AMD64_LINK_PROGRAM_OUTPUT_MAYBE = $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80AMD64_LINK_PROGRAM_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_LD) $(flags) \
@@ -293,7 +259,8 @@
 #
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
-TOOL_VCC80AMD64_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80AMD64_LINK_DLL_DEPEND = $(objs) $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80AMD64_LINK_DLL_DEPORD = $(call DIRDEP,$(PATH_LIB))
+TOOL_VCC80AMD64_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp
+TOOL_VCC80AMD64_LINK_DLL_OUTPUT_MAYBE = $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80AMD64_LINK_DLL_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_LD) $(flags) \
@@ -333,7 +300,8 @@
 #
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
-TOOL_VCC80AMD64_LINK_SYSMOD_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80AMD64_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80AMD64_LINK_SYSMOD_DEPORD =
+TOOL_VCC80AMD64_LINK_SYSMOD_OUTPUT = $(outbase).map
+TOOL_VCC80AMD64_LINK_SYSMOD_OUTPUT_MAYBE = $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80AMD64_LINK_SYSMOD_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_LD) $(flags) \
Index: /trunk/kBuild/tools/VCC80X86.kmk
===================================================================
--- /trunk/kBuild/tools/VCC80X86.kmk	(revision 1030)
+++ /trunk/kBuild/tools/VCC80X86.kmk	(revision 1031)
@@ -122,8 +122,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80X86_COMPILE_C_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
 TOOL_VCC80X86_COMPILE_C_DEPEND =
 TOOL_VCC80X86_COMPILE_C_DEPORD =
-ifndef VCC80X86_OLD_DEPS
+TOOL_VCC80X86_COMPILE_C_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
 define TOOL_VCC80X86_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC80X86_CC) -c\
@@ -135,17 +134,4 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80X86_PDB,$(outbase)-obj,idb)
 endef
-else
-define TOOL_VCC80X86_COMPILE_C_CMDS
-	$(QUIET)$(TOOL_VCC80X86_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		-Fd$(outbase)-obj.pdb \
-		-Fo$(obj)\
-		$(subst /,\\,$(abspath $(source)))
-	$(QUIET)$(TOOL_VCC80X86_CC) -E\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		$(subst /,\\,$(abspath $(source)))\
-		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
-endef
-endif
 
 
@@ -163,8 +149,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80X86_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
 TOOL_VCC80X86_COMPILE_CXX_DEPEND =
 TOOL_VCC80X86_COMPILE_CXX_DEPORD =
-ifndef VCC80X86_OLD_DEPS
+TOOL_VCC80X86_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
 define TOOL_VCC80X86_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC80X86_CXX) -c\
@@ -176,17 +161,4 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC80X86_PDB,$(outbase)-obj,idb)
 endef
-else
-define TOOL_VCC80X86_COMPILE_CXX_CMDS
-	$(QUIET)$(TOOL_VCC80X86_CXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		-Fd$(outbase)-obj.pdb \
-		-Fo$(obj)\
-		$(subst /,\\,$(abspath $(source)))
-	$(QUIET)$(TOOL_VCC80X86_CXX) -E\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
-		$(subst /,\\,$(abspath $(source)))\
-		| $(DEP_PRE) -f -s -o $(dep) -t $(obj) -
-endef
-endif
 
 ## @todo configure the assembler template.
@@ -205,7 +177,7 @@
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
 # @param    $(objsuff)  Object suffix.
-TOOL_VCC80X86_COMPILE_RC_OUTPUT =
 TOOL_VCC80X86_COMPILE_RC_DEPEND =
 TOOL_VCC80X86_COMPILE_RC_DEPORD =
+TOOL_VCC80X86_COMPILE_RC_OUTPUT =
 define TOOL_VCC80X86_COMPILE_RC_CMDS
 	$(QUIET)$(TOOL_VCC80X86_RC) \
@@ -228,6 +200,6 @@
 TOOL_VCC80X86_LINK_LIBRARY_DEPEND = $(othersrc)
 TOOL_VCC80X86_LINK_LIBRARY_DEPORD =
-ifeq ($(filter append-dash-n,$(KMK_FEATURES)),append-dash-n)
-TOOL_VCC80X86_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(outbase).pdb $(outbase).rsp
+TOOL_VCC80X86_LINK_LIBRARY_OUTPUT = $(outbase).rsp
+TOOL_VCC80X86_LINK_LIBRARY_OUTPUT_OUTPUT = $(outbase).lst $(outbase).exp $(outbase).pdb
 define TOOL_VCC80X86_LINK_LIBRARY_CMDS
 	$(QUIET)$(APPEND) -n $(outbase).rsp \
@@ -239,11 +211,4 @@
 	$(QUIET)$(TOOL_VCC80X86_AR) $(flags) /OUT:$(out) @$(outbase).rsp
 endef
-else
-TOOL_VCC80X86_LINK_LIBRARY_OUTPUT = $(outbase).lst $(outbase).exp $(outbase).pdb
-define TOOL_VCC80X86_LINK_LIBRARY_CMDS
-	$(QUIET)$(TOOL_VCC80X86_AR) $(flags) /OUT:$(out) $(subst /,\\,$(objs) $(filter %.a %.lib,$(othersrc))) \
-		$(foreach def,$(filter %.def,$(othersrc)), /DEF:$(def))
-endef
-endif
 
 
@@ -262,7 +227,8 @@
 # @param    $(outbase)      Output basename (full). Use this for list files and such.
 #
-TOOL_VCC80X86_LINK_PROGRAM_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80X86_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80X86_LINK_PROGRAM_DEPORD =
+TOOL_VCC80X86_LINK_PROGRAM_OUTPUT = $(outbase).map
+TOOL_VCC80X86_LINK_PROGRAM_OUTPUT_MAYBE = $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80X86_LINK_PROGRAM_CMDS
 	$(QUIET)$(TOOL_VCC80X86_LD) $(flags) \
@@ -295,7 +261,8 @@
 #
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
-TOOL_VCC80X86_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80X86_LINK_DLL_DEPEND = $(objs) $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80X86_LINK_DLL_DEPORD = $(call DIRDEP,$(PATH_LIB))
+TOOL_VCC80X86_LINK_DLL_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp
+TOOL_VCC80X86_LINK_DLL_OUTPUT_MAYBE = $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80X86_LINK_DLL_CMDS
 	$(QUIET)$(TOOL_VCC80X86_LD) $(flags) \
@@ -335,7 +302,8 @@
 #
 # @param    $(outbase)  Output basename (full). Use this for list files and such.
-TOOL_VCC80X86_LINK_SYSMOD_OUTPUT = $(outbase).map $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 TOOL_VCC80X86_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) $(othersrc)
 TOOL_VCC80X86_LINK_SYSMOD_DEPORD =
+TOOL_VCC80X86_LINK_SYSMOD_OUTPUT = $(outbase).map
+TOOL_VCC80X86_LINK_SYSMOD_OUTPUT_MAYBE = $(outbase).lib $(outbase).exp $(outbase).pdb $(outbase).ilk $(out).manifest
 define TOOL_VCC80X86_LINK_SYSMOD_CMDS
 	$(QUIET)$(TOOL_VCC80X86_LD) $(flags) \